package org.artifactory.repo.system.suppliers;

import lombok.extern.slf4j.Slf4j;
import org.artifactory.api.config.CentralConfigService;
import org.artifactory.descriptor.config.MutableCentralConfigDescriptor;
import org.artifactory.descriptor.repo.LocalRepoDescriptor;
import org.artifactory.descriptor.repo.releasebundle.ReleaseBundlesRepoDescriptor;

import static org.artifactory.descriptor.repo.RepoType.ReleaseBundles;

/**
 * @author Tomer Slutsky
 */
@Slf4j
public class ReleaseBundleRepo extends SystemRepoBase {

    public ReleaseBundleRepo(CentralConfigService centralConfigService) {
        super(centralConfigService);
    }

    @Override
    public LocalRepoDescriptor buildDescriptor(String repoKey) {
        LocalRepoDescriptor repo = new ReleaseBundlesRepoDescriptor();
        repo.setKey(repoKey);
        repo.setType(ReleaseBundles);
        return repo;
    }

    @Override
    public void addToRepoList(MutableCentralConfigDescriptor mutableDescriptor, LocalRepoDescriptor descriptor) {
        mutableDescriptor.addReleaseBundlesRepository((ReleaseBundlesRepoDescriptor) descriptor);
    }
}
