package org.artifactory.util;

import org.springframework.util.StopWatch;

import java.util.concurrent.Callable;

/**
 * @author Mor Merhav
 */
public final class StopWatchUtil {


    private StopWatchUtil() {
    }

    public static <T> T measureTime(StopWatch stopWatch, Callable<T> callable) throws Exception {
        try {
            stopWatch.start();
            T result = callable.call();
            stopWatch.stop();
            return result;
        } catch (Exception e) {
            stopWatch.stop();
            throw e;
        }
    }
}
