package org.artifactory.work.queue.mbean.gems;

import org.artifactory.work.queue.mbean.WorkQueueMBean;

/**
 * Gems compact index for virtual repositories related job queue.
 *
 * @author Rotem Kfir
 */
public class GemsVirtualWorkQueue implements GemsVirtualWorkQueueMBean {

    private WorkQueueMBean workQueueMBean;

    public GemsVirtualWorkQueue(WorkQueueMBean workQueueMBean) {
        this.workQueueMBean = workQueueMBean;
    }

    @Override
    public int getQueueSize() {
        return workQueueMBean.getQueueSize();
    }

    @Override
    public int getNumberOfWorkers() {
        return workQueueMBean.getNumberOfWorkers();
    }

    @Override
    public int getMaxNumberOfWorkers() {
        return workQueueMBean.getMaxNumberOfWorkers();
    }

    @Override
    public String getName() {
        return workQueueMBean.getName();
    }
}
