/*
 *
 * Artifactory is a binaries repository manager.
 * Copyright (C) 2018 JFrog Ltd.
 *
 * Artifactory is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 * Artifactory is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Artifactory.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.artifactory.api.bintray;

import org.artifactory.api.bintray.exception.BintrayException;
import org.artifactory.api.search.BintrayItemSearchResults;
import org.artifactory.descriptor.repo.RemoteRepoDescriptor;

import javax.annotation.Nullable;
import java.io.IOException;
import java.util.Map;

/**
 * Provides different Bintray related business methods
 *
 * @author Shay Yaakov
 */
public interface BintrayService {

    String PATH_PACKAGES = "packages";

    /**
     * Search for a files by name, can take the * and ? wildcard characters.
     */
    BintrayItemSearchResults<BintrayItemInfo> searchByName(String query, @Nullable Map<String, String> headersMap)
            throws IOException, BintrayException;

    /**
     * Retrieves JCenter repo
     */
    RemoteRepoDescriptor getJCenterRepo();
}
