package org.artifactory.aql.model;

import lombok.Builder;
import lombok.Data;
import org.artifactory.aql.result.AqlJsonStreamer;

import java.util.List;

/**
 * @author Omri Ziv
 */
@Data
@Builder
public class AqlOverloadSettings {
    private Long limit;
    private Long offset;
    private AqlSortTypeEnum sortType;
    private AqlPhysicalFieldEnum sortField;
    private AqlStreamFunc streamFunc;
    private List<DomainSensitiveField> resultFields;

    @FunctionalInterface
    public interface AqlStreamFunc {
        List<AqlJsonStreamer> apply(String skip, AqlPermissionProvider aqlPermissionProvider);
    }
}
