package org.artifactory.rest.services.artifact.lifecycle;

import org.artifactory.addon.AddonsManager;
import org.artifactory.addon.artifact.lifecycle.ArtifactLifecycleAddon;
import org.artifactory.addon.artifact.lifecycle.ArtifactLifecyclePolicyModel;
import org.artifactory.rest.common.service.ArtifactoryRestRequest;
import org.artifactory.rest.common.service.RestResponse;
import org.artifactory.rest.common.service.RestService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author Omri Ziv
 */
@Component
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
public class GetAllArtifactLifecyclePolicyService implements RestService {

    @Autowired
    private AddonsManager addonsManager;

    @Override
    public void execute(ArtifactoryRestRequest request, RestResponse response) {
        ArtifactLifecycleAddon artifactLifecycleAddon = addonsManager.addonByType(ArtifactLifecycleAddon.class);
        List<ArtifactLifecyclePolicyModel> policyModels = artifactLifecycleAddon.getPolicies();
        response.iModel(policyModels);
    }
}
